
local BossDataHandler = class("BossDataHandler")

local cclog = function(...)
    print(string.format(...))
end


function BossDataHandler:ctor()
	self:initData()
	self:registerEventListener()
end

function BossDataHandler:getInstance()
	if not self.instance then
		self.instance = BossDataHandler.new()
	end
	return self.instance
end

function BossDataHandler:destroyInstance()
    if self.instance then
        self.instance = nil
    end
end


function BossDataHandler:initData()

end

function BossDataHandler:setFightBossId(id)
	self.fightBossId = id
end

function BossDataHandler:requestFightBoss()
	if self.fightBossId then
		wd.TranscodingSend:fightBoss(self.fightBossId)
	end
end

function BossDataHandler:requestBuyBossChanllengeNumber()
	wd.TranscodingSend:buyBossNumber()
end

function BossDataHandler:getItemList(dropStr)
	local awardList = {}
	local id,itemCount,probability,startIndex,endIndex
	local str = dropStr
	while(str ~= "")
	do
		local item = {}
		startIndex,endIndex,id,itemCount,probability = string.find(str,"(%d+)|(%d+):(%d+)")
		item.id = tonumber(id)
		item.itemCount = tonumber(itemCount)
		--[[if item.id == 1034 then
			item.itemType = wd.rewardItemType.MAIL_GEM
			item.itemCount = item.itemCount*50
		elseif item.id == 1035 then
			item.itemType = wd.rewardItemType.MAIL_GEM
			item.itemCount = item.itemCount*100
		else
			item.itemType = wd.rewardItemType.MAIL_ITEM
		end--]]
		table.insert(awardList,item)
		str = string.sub(str,endIndex+2,-1)
	end
	return awardList
end

function BossDataHandler:registerEventListener()
	
	-- 从服务器接收技能列表回调

	--[[local function onOpenDiscountShop(EventCustom)
		
		local event = cc.EventCustom:new("Update_DiscountList")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	
	local listenerOpenShop = cc.EventListenerCustom:create("Open_DiscountShop", onOpenDiscountShop)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerOpenShop, 1)--]]
end

return BossDataHandler
