if nil == wd then
    return
end

wd.RANKINGMAX = 20


wd.ServerStatus = {
    NEW = 0,
    HOT = 1,
    FULL = 2,
    MAINTAIN  = 3,
    RESERVED1   = 4,
    RESERVED2  = 5,
}

wd.TCSdk_ePlatform = 
{
	ePlatform_None = 0,
	ePlatform_Weixin = 1,
    ePlatform_QQ = 2,
    ePlatform_WTLogin = 3,
	ePlatform_QQHall = 4,
}
 

wd.ServerStatusName = {
    [wd.ServerStatus.NEW] = "login_new_title.png",
    [wd.ServerStatus.HOT] = "login_hot_title.png",
    [wd.ServerStatus.FULL] = "login_maintain_title.png",
    [wd.ServerStatus.MAINTAIN] = "login_maintain_title.png",
    [wd.ServerStatus.RESERVED1] = "login_hot_title.png",
    [wd.ServerStatus.RESERVED2] = "login_hot_title.png",
}


wd.newGuideStep = {
	Battle = 1,
	Quick = 2,
	QuickEnter = 3,
	QuickClose = 4,
	BackMain = 5,
	Role = 6,
	EquipBox = 7,
	EquipSelect = 8,
	EquipWear = 9,
	WeardEquip = 10,
	Strength = 11,
	StrengthEnter = 12,
}
wd.newGuidePos = {}

wd.newGuideDir = {
	[1] = "bottom",
	[2] = "left",
	[3] = "top",
	[4] = "top",
	[5] = "bottom",
	[6] = "right",
	[7] = "top",
	[8] = "top",
	[9] = "bottom",
	[10] = "top",
	[11] = "bottom",
	[12] = "bottom",
}

wd.newGuideIsShowTalk = {
	[1] = true,
	[2] = true,
	[3] = false,
	[4] = false,	
	[5] = true,
	[6] = true,
	[7] = true,
	[8] = false,
	[9] = true,
	[10] = true,
	[11] = true,
	[12] = true,
}
wd.ItemType =
    {
        Tools = 1,
        Equip = 2,
        EquipList = 3,
        Special = 4,
		Soul = 5,
        ServerEquip = 6,
    }


wd.ItemId = 
    {
        Gem = 1,
        Gold = 2,
        ChallengeCount = 3,
        ActionPower = 4,
        MemberPoints = 5,
        KillPoints = 6,
        HonorPoints = 7,
        ArtifactPoints = 8,
        SkillExperience = 9,
        SuperChest = 1013,
        SuperAssociate = 1014,
        SilverChest = 1015,
        SilverAssociate = 1016,
        
        StrengthenStone = 1020,
        ProtectStone = 1021,
        ChangeStone = 1022,
        UpStone = 1023,
		
		SkillDrug = 1024,
		
		KillWashDrug = 1030,
		
		Soul_1 = 1071,
		Soul_2 = 1072,
		Soul_3 = 1073,
		Soul_4 = 1074,
		Soul_5 = 1075,
		Soul_6 = 1076,
		SoulBlood = 1077,
		SoulDrug = 1078,
		SoulToken = 1079,
		SoulSpecial_1 = 1080,
		SoulSpecial_2 = 1081,
		
    }
    
wd.ViewGetType = 
    {
        Get = 0,
        Preview = 1,
    }


wd.FilterType = 
    {
        NO_FLITER = 0,
        REGION = 1,
        COLOR = 2,
    }
    
wd.RegionType = 
    {
        ALL = 0,
        WEAPON = 1,
        BREASTPLATE = 2,
        HELMET = 3,
        SHOE = 4,
        NECKLACE = 5,
        WRIST = 6,
        RING = 7,
    }
    
wd.WearRegion = 
    {
        NOTHING = -1,
        Reserved = 0,
        WEAPON = 1,
        BREASTPLATE = 2,
        HELMET = 3,
        SHOE = 4,
        NECKLACE = 5,
        LWRIST = 6,
        LRING = 7,
        RWRIST = 8,
        RRING = 9,
    }
    
wd.ColorType = 
    {
        Reserved = 0,
        WHITE = 1,
        GREEN = 2,
        BLUE = 3,
        PURPLE = 4,
        GOLD = 5,
    }
    
wd.PlayerType = 
    {
        SELF = 0,
        ENEMY = 1,
    }

wd.ActionType =
    {
        HP_CHANGE = 1,
        MP_CHANGE = 2,
        DOD_OCCUR = 3,
        CRIT_OCCUR = 4,
        RESET_MP = 5,
        RESET_HP = 6,
		ADD_BUFF = 7,
		DEC_BUFF = 8,
		DOUBLE_HIT = 9,
		STRIKE_BACK = 10,
		RAIN_HP =11, --//复活血量
		RAIN_MP = 12, --//复活魔法值

    }
	
wd.MailType = 
{
	SYSTEM_GIVE_AWARD = 1, --/*系统补偿奖励*/
	ARENA_AWARD = 2 , --/*排行榜奖励*/
	HOLIDAY_AWARD = 3, --/*节假日奖励*/
	ARENA_REVENGE = 4, --/*竞技场复仇邮件*/
	PKMAPDROPEQUIP = 5,--/*PK地图掉装*/
}


wd.ArenaRevengeType = 
	{
		Winner = 1,
		Loser = 2,
		PK_WINER = 3,--//pk地图成功者邮件
		PK_LOSER = 4,--//pk地图失败者邮件
	}

wd.MailReadState = 
	{
		READED = 1,
		NO_READ = 2,
		TAKE_AWAY = 3, --已提取
		REVENGEED = 4, --复仇成功

	}
    
wd.rewardItemType = 
	{
		MAIL_GEM = 1,	--/*元宝*/
		MAIL_MONEY = 2,	--/*金币*/
		MAIL_ITEM = 3,	--/*道具*/
		MAIL_EQUIPMENT = 4,--	/*装备*/
	}
	
wd.awardType = 
	{
		ACHIEVE = 1 , --成就奖励
	}
	
wd.helpType = 
	{
		Sub = 0,
		Total = 1,
	}
	
wd.helpTag = 
	{
		Arena = 1,
		Skill = 2,
		Tripod = 3,
		Smelting = 4,
		Welfare = 5,
		PkMap = 6,
		FamilyGurade = 7,
		FamilyBat = 8,
	}
	
wd.PK_TYPE = 
	{
		ATTACKED_FAIL = 1,--/*被pk，失败*/
		ATTACKED_FAIL_LOSE= 2,--/*被PK失败，掉装备*/
		ATTACKED_SUCCESS= 3,--/*被PK胜利*/
		ATTACK_FAIL= 4,--/*主动PK失败*/
		ATTACK_SUCCESS= 5,--/*主动PK胜利*/
		ATTACK_SUCCESS_GET= 6,--/*主动PK，获得装备*/
	}
	
	
wd.activityType = 
{
    Everyday = 1,
	Fund = 2,
    Vip = 3,
    Charge = 4,
	Consume = 5,
	
    
    
}

wd.activityInfo = 
{
    [wd.activityType.Everyday] = {id = 104,isShow = true,  png ="spree_sprite_4.png",title = "每日充值",describe = "快乐领奖"},
	[wd.activityType.Fund] = {id = 100,isShow = true,  png = "spree_sprite_6.png",title = "等级基金",describe = "10倍返还"},
    [wd.activityType.Vip] = {id = 105,isShow = true,  png ="spree_sprite_1.png",title = "会员特礼",describe = "免费领取"},
	[wd.activityType.Charge] = {id = 101,isShow = true,  png ="spree_sprite_3.png",title = "累积充值",describe = "超级豪礼"},
	[wd.activityType.Consume] = {id = 102,isShow = true,  png = "spree_sprite_2.png",title = "累计消费",describe = "也送好礼"},
}

-- 开服活动类型
wd.openActivityType = 
{
	SevenDay = 1,
	ChargeDay = 2,
	ChargeAct = 3,
	ConsumeAct = 4,
	LevelRank = 5,
	AreneRank = 6,
    PowerRank = 7,
}

-- 开服活动信息
wd.openActivityInfo = 
{
	[wd.openActivityType.SevenDay]   = {id = 1001,isShow = true,text = "七天任务奖励"},
	[wd.openActivityType.ChargeDay]  = {id = 1002,isShow = true,text = "累积充值天数"},
	[wd.openActivityType.ChargeAct]  = {id = 1003,isShow = true,text = "累计充值活动"},
	[wd.openActivityType.ConsumeAct] = {id = 1004,isShow = true,text = "消费宝箱活动"},
	[wd.openActivityType.LevelRank]  = {id = 1005,isShow = true,text = "等级排名奖励"},
	[wd.openActivityType.AreneRank]  = {id = 1006,isShow = true,text = "竞技排名奖励"},
    [wd.openActivityType.PowerRank]  = {id = 1007,isShow = true,text = "战力排名奖励"},
}

wd.awardState = {
	Unreach = -1,
	HadGet = 0,
	CanGet = 1,
}

wd.tipsType = {
	Get = 1,
	Buy = 2,
	Open = 3,
	System = 4,
}

wd.tipsBoxSprite = {
	[1] = "tips_box_1.png",
	[2] = "tips_box_2.png",
	[3] = "tips_box_2.png",
	[4] = "tips_box_2.png",
}

wd.tipsBoxSize = {
	[1] = cc.size(492,50),
	[2] = cc.size(421,50),
	[3] = cc.size(421,66),
	[4] = cc.size(421,50),
}

wd.openKey = {
	PkMap = 1,
	Arena = 2,
	SoulShop = 3,
	Soul = 4,
	Family = 5,
    Ectype = 6,
}

wd.openCondiction = 
{
	[wd.openKey.PkMap] = {level = 12,msg = {[1] = "探索",[2] = "{o=[12]}",[3] = "级开启，可得到元宝等大量珍稀道具及杀戮爆装的乐趣哟。"}}, 
	[wd.openKey.Arena] = {level = 15,msg = {[1] = "竞技战场",[2] = "{o=[15]}",[3] = "级开启，挑战对手得黑铁矿石，还可爆掉对手身上的装备哦。"}}, 
	[wd.openKey.SoulShop] = {level = 10,msg = {[1] = "天魂灵殿",[2] = "{o=[10]}",[3] = "级开启，可通过试炼或神祈可以获得大量天魂"}}, 
	[wd.openKey.Soul] = {level = 10,msg = {[1] = "天魂",[2] = "{o=[10]}",[3] ="级开启，它具有噬魂、引魂等玩法，可培养出无敌天魂。"}}, 
	[wd.openKey.Family] = {level = 17,msg = {[1] = "家族",[2] = "{o=[17]}",[3] = "级开启，加入家族可体验团队合作及家族城战等激情玩法。"}}, 
    [wd.openKey.Ectype] = {level = 16,msg = {[1] = "副本",[2] = "{o=[16]}",[3] = "级开启，可消灭副本BOSS获得大量道具等物品。"}}, 
}

wd.newWelcomeKey = {
	Battle = 1,
	Arena = 2,
	Skill = 3,
	PK = 4,
	Tripod = 5,
}

wd.actionTable = {[1]="HP_CHANGE",[2]="MP_CHANGE",[3]="闪避",[4]="暴击",[5]="RESET_MP",[6]="RESET_HP",[7]="ADD_BUFF",[8]="DEC_BUFF",[9]="连击",[10]="反震",[11] = "复活"}

wd.skillTable = {[0]="普通攻击",[2]="MP_CHANGE",[3]="闪避",[4]="暴击",[5]="RESET_MP",[6]="RESET_HP",[7]="ADD_BUFF",[8]="DEC_BUFF",[9]="连击",[10]="反震"}

wd.colorTable = {[1]=cc.c4b(0xff,0xff,0xff,0xff), [2]=cc.c4b(0x09,0x66,0x43,0xff), [3]=cc.c4b(0x01,0xc0,0xff,0xff), [4]=cc.c4b(0xf0,0x4e,0xff,0xff), [5]=cc.c4b(0xff,0xe1,0x3d,0xff), [6]=cc.c4b(0xff,0x22,0x22,0xff)}
    
wd.battleColorTable = {["myself"] = cc.c3b(0x39, 0x11, 0xaa),["enemy"] = cc.c3b(0,0x68,0xc0),["skill"] = cc.c3b(0x89,0x51,0x01),["value"] = cc.c3b(0x83,0,0),["MPvalue"] = cc.c3b(0,0x68,0xc0),["type"] = cc.c3b(0x22,0x68,0x00),["item"] = cc.c3b(0x22,0x68,0x00),["offlne"] = cc.c3b(0,0xff,0),["common"] = cc.c3b(0, 0, 0)}

wd.announcementColor = { ["PURPLE"] = cc.c3b(180,99,232) , ["BLUE"] = cc.c3b(99,159,232),["RED"] = cc.c3b(255,0,0),["YELLOW"] = cc.c3b(255,243,113)}
function wd.actionTypeString(type)
    return wd.actionTable[type]
end

function wd.colorType(color)
    return wd.colorTable[color]
end

function wd.showSystemTips(msg,color,fontSize,pos)
	local tipsLayer = wd.tipsLayerClass:getInstance()
	tipsLayer:showTips(msg,color,fontSize,pos)
end

function wd.showAttributeTips(msg,color,fontSize,pos)
	local tipsLayer = wd.attrTipsLayer:getInstance()
	tipsLayer:showTips(msg,color,fontSize,pos)
end

function wd.showRichTips(msgType,msg,color)
	local tipsLayer = wd.richTipsLayer:getInstance()
	tipsLayer:showTips(msgType,msg,color)
end

function wd.setSelectBox(node,lastTag,curTag)
    if lastTag ~= nil then
        local lastBtn = node:getChildByTag(lastTag)
        if lastBtn then 
            local lastNode = lastBtn:getChildByTag(lastTag)
            local lastSelectBox = tolua.cast(lastNode:getChildByName("Select_Sprite"), "cc.Sprite")
            if lastSelectBox then
                lastSelectBox:setVisible(false)
            end
        end
    end    
    
    if curTag ~= nil then
	   local curBtn = node:getChildByTag(curTag)
	   if curBtn then
		  local curNode = curBtn:getChildByTag(curTag)
		  local curSelectBox = tolua.cast(curNode:getChildByName("Select_Sprite"), "cc.Sprite")
		  if curSelectBox then
			 curSelectBox:setVisible(true)
		  end
	   end
	end
end
	
function wd.getItemInfo(getData)
	local startIndex,lastIndex,type,id,count  = string.find(getData,"(%d+)#(%d+)|(%d+)")

	if type == nil or id == nil or count == nil then
		return
	end

	type = tonumber(type)
	id = tonumber(id)
	count = tonumber(count)
	local itemInfo = {}
	if count > 0 then
		if type == wd.ItemType.Tools then
			local item = wd.GlobalData:getInstance():getToolsItemForId(id)
			if item then
				itemInfo.name = item:getName()
				itemInfo.color = item:getQuality()
				itemInfo.count = count
			end
		elseif type == wd.ItemType.Equip then
			local equip = wd.GlobalData:getInstance():getEquipItemForId(id)
			if equip then
				itemInfo.name = equip:getName()
				itemInfo.color = equip:getColor()
				itemInfo.count = 1
			end
		elseif type == wd.ItemType.Special then
			if id == 1 then
				itemInfo.name = "元宝"
				itemInfo.color = 5
				itemInfo.count = count
			elseif id == 2 then
				itemInfo.name = "金币"
				itemInfo.color = 5
				itemInfo.count = count
			end
		elseif type == wd.ItemType.Soul then
			local soul = wd.GlobalData:getInstance():getSoulItemForId(id)
			if soul then
				itemInfo.name = soul:getName()
				itemInfo.color = soul:getGrade()
				itemInfo.count = 1
			end
		end
		return itemInfo
	end
end

function wd.getItemInfoList(getData)
    local list = {}
    while getData ~= "" do
        local item = wd.getItemInfo(getData)
        table.insert(list,item)
        local startIndex,lastIndex = string.find(getData,"(%d+)#(%d+)|(%d+)")
        getData = string.sub(getData,lastIndex + 1,-1)
    end
    return list
end

function wd.getEquipInfo(getData)
	local id = {}
	while getData ~= "" do
		local dataIndex = string.find(getData,"|")
		local idItem = string.sub(getData,1,dataIndex-1)
		table.insert(id,tonumber(idItem))
		getData = string.sub(getData,dataIndex + 1,-1)
	end
	
	local itemInfo = {}
	for k,v in pairs(id) do	
		local equip = wd.GlobalData:getInstance():getEquipItemForId(v)
		if equip then
			local item = {}
			item.name = equip:getName()
			item.color = equip:getColor()
			table.insert(itemInfo,item)
		end
	end
	return itemInfo
end

function wd.showAttributeChangeTip()
	local oldRole = wd.GlobalData:getInstance():getOldRoleData()
	local newRole = wd.GlobalData:getInstance():getRoleData()
	local roleAttributeClass = require("src.game.RoleAttribute"):getInstance()
	for i,v in pairs(roleAttributeClass.RoleBaseAttribute) do
		local changeValue = v.getFunc(newRole) - v.getFunc(oldRole)
		if changeValue ~= 0 then
			local sign = (changeValue < 0) and "" or "+"
			local color = (changeValue < 0) and cc.c3b(255,0,0) or cc.c3b(0,255,0)
			changeValue = tostring(changeValue)
			if i == "Vertigo" or i == "Manaprevent" or i == "Reincarnate" or i == "Drainlife" then
				changeValue = changeValue.."%"
			end
			wd.showRichTips(4,string.format("%s %s%s",v.name,sign,changeValue),color)
		end
	end
end


function wd.checkOpen(key)
	local role = wd.GlobalData:getInstance():getRoleData()
	for i,v in ipairs(wd.openCondiction) do
		if key == i then
			if role:getLevel() >= v.level then
				return true
			else
				return false,v.msg
			end
		end
	end
end

-- 打印table
function wd.printLuaTable(lua_table, indent)
    indent = indent or 0
    for k, v in pairs(lua_table) do
        local szSuffix = ""
        local TypeV = type(v)
        if TypeV == "table" then
            szSuffix = "{"
        end
        local szPrefix = string.rep(" ", indent)
        local formatting = szPrefix..k.." = "..szSuffix
        if TypeV == "table" then
            print(formatting)
            wd.printLuaTable(v, indent + 1)
            print(szPrefix.."},")
        else
            local szValue = ""
            if TypeV == "string" then
                szValue = string.format("%q", v)
            else
                szValue = tostring(v)
            end
            print(formatting..szValue..",")
        end
    end
end

function wd.cgq( ... )
    print("↓--------cgq----print--------↓")
    for _, v in pairs({...}) do 
        if type(v) == "table" then
            wd.printLuaTable(v)
        else
            print(v)
        end
    end 
    print("↑--------cgq----print--------↑")
end