if nil == wd then
    return
end

if wd.battleHandler and wd.battleHandler.destroyInstance then
    wd.battleHandler:destroyInstance()
end

if wd.mailHandler and wd.mailHandler.destroyInstance then
    wd.mailHandler:destroyInstance()
end

if wd.chatHandler and wd.chatHandler.destroyInstance then
    wd.chatHandler:destroyInstance()
end

if wd.giftHandler and wd.giftHandler.destroyInstance then
    wd.giftHandler:destroyInstance()
end

if wd.familyHandler and wd.familyHandler.destroyInstance then
    wd.familyHandler:destroyInstance()
end

if wd.bossHandler and wd.bossHandler.destroyInstance then
    wd.bossHandler:destroyInstance()
end

if wd.skillHandler and wd.skillHandler.destroyInstance then
    wd.skillHandler:destroyInstance()
end

if wd.shopHandler and wd.shopHandler.destroyInstance then
    wd.shopHandler:destroyInstance()
end

if wd.pkHandler then
    wd.pkHandler:destroyInstance()
end

if wd.activityHandler then
    wd.activityHandler:destroyInstance()
end

if wd.soulHandler then
    wd.soulHandler:destroyInstance()
end

package.loaded["src.game.battle.BattleWordDataHandler"] = nil
package.loaded["src.game.mail.MailDataHandler"] = nil
package.loaded["src.game.chat.ChatDataHandler"] = nil
package.loaded["src.game.gift.GiftDataHandler"] = nil
package.loaded["src.game.family.FamilyDataHandler"] = nil
package.loaded["src.game.boss.BossDataHandler"] = nil
package.loaded["src.game.skill.SkillDataHandler"] = nil
package.loaded["src.game.shop.ShopDataHandler"] = nil
package.loaded["src.game.map.PKMapDataHandler"] = nil
package.loaded["src.game.activity.ActivityDataHandler"] = nil
package.loaded["src.game.soul.SoulDataHandler"] = nil

wd.battleHandler = nil
wd.mailHandler = nil
wd.chatHandler = nil
wd.giftHandler = nil
wd.familyHandler = nil
wd.bossHandler = nil
wd.skillHandler = nil
wd.shopHandler = nil
wd.pkHandler = nil
wd.activityHandler = nil
wd.soulHandler = nil

wd.skillHandler =  require("src.game.skill.SkillDataHandler"):getInstance()
wd.battleHandler = require("src.game.battle.BattleWordDataHandler"):getInstance()
wd.mailHandler = require("src.game.mail.MailDataHandler"):getInstance()
wd.chatHandler = require("src.game.chat.ChatDataHandler"):getInstance()
wd.giftHandler = require("src.game.gift.GiftDataHandler"):getInstance()
wd.familyHandler = require("src.game.family.FamilyDataHandler"):getInstance()
wd.bossHandler =  require("src.game.boss.BossDataHandler"):getInstance()
wd.shopHandler = require("src.game.shop.ShopDataHandler"):getInstance()
wd.pkHandler =require("src.game.map.PKMapDataHandler"):getInstance()
wd.activityHandler = require("src.game.activity.ActivityDataHandler"):getInstance()
wd.soulHandler = require("src.game.soul.SoulDataHandler"):getInstance()
